import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mylibrary/config/const.dart';
import 'package:flutter_mylibrary/utils/utils.dart';
import 'package:flutter_mylibrary/widget/widget_template.dart';
import '../flutter_mylibrary.dart';
import 'base_view_state.dart';

mixin BaseRequestModelController<T> on BaseViewState{

  T data;


  void getData(){
    request((httpData) {
      this.data = httpData.data;
      onCompleted(this.data);
      setIdle();
      refreshController.finishRefresh();
    });

  }

  onCompleted(T data) {}

  ///获取一个公共的刷新控件
  Widget getEasyRefreshWidget({bool useSliverWidget = false, Widget headerWidget, Widget footWidget, Widget emptyWidget, ViewStateModelWidgetListBuilder<T> widgetListBuilder, ViewStateModelWidgetBuilder<T> builder, Widget busyWidget, bool showErrorWidget = true, bool showEmptyWidget = true, bool showBusyWidget = true, OnLoadCallback onLoad}){
    Widget emptyErrorWidget = buildRefreshNoDataWidget(viewState: this, busyWidget: busyWidget, emptyDataWidget: emptyWidget, showErrorWidget: showErrorWidget, showEmptyWidget: showEmptyWidget, showBusyWidget: showBusyWidget);
    if(isEmpty(headerWidget) && isEmpty(footWidget)){
      return EasyRefresh(
        emptyWidget: emptyErrorWidget,
        child: isEmpty(emptyErrorWidget)? builder(data) : Container(),
        onRefresh: isBusy? null : () async{
          getData();
        },
        onLoad: onLoad,
        controller: refreshController,
      );
    }else{
      return Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Expanded(
            child: useSliverWidget? EasyRefresh.custom(
              emptyWidget: emptyErrorWidget,
              onRefresh: isBusy? null : () async{
                getData();
              },
              onLoad: onLoad,
              controller: refreshController,
              slivers: isBusy || isError? [SliverToBoxAdapter(
                child: Container(),
              )] : isNotEmpty(widgetListBuilder)? widgetListBuilder(data) : [isEmpty(emptyErrorWidget)? isNotEmpty(builder)? builder(data) : SliverToBoxAdapter(child: Container(),) :SliverToBoxAdapter(child: Container(),),],
            ) : EasyRefresh(
              emptyWidget: emptyErrorWidget,
              child: isEmpty(emptyErrorWidget)? builder(data) : Container(),
              onRefresh: isBusy? null : () async{
                getData();
              },

              onLoad: onLoad,
              controller: refreshController,
            ),
          ),
          footWidget??Container(),
        ],
      );
    }
  }



  void requestWhenError(){
    setBusy();
    getData();
  }
}